import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner

class MainTest(unittest.TestCase):

    def test_answer(self):

        def main_test(X_train, X_test, Y_train, Y_test):
            Y_predict = np.empty(len(Y_test), dtype=np.int64)
            
            k = 3
            N_train = len(X_train)
            N_test = len(X_test)
            
            for i in range(N_test):
                D = np.empty(N_train)
                for j in range(N_train):
                    D[j] = dist(X_train[j], X_test[i])
            
                near = np.argsort(D)[:k ]
            
                Y_predict[i] = np.round(np.mean(Y_train[near]))
   
            return str(Y_predict)

        for i in range(10):
            X, Y = make_blobs(n_samples=16, n_features=2, centers=2, center_box=(-2,2))
            X = MinMaxScaler().fit(X).transform(X)
            X_train, X_test, Y_train, Y_test = train_test_split(X, Y, test_size = 2)

            capturedOutput = io.StringIO()                 
            sys.stdout = capturedOutput                     
            main(X_train, X_test, Y_train, Y_test)
            sys.stdout = sys.__stdout__ 
            output = capturedOutput.getvalue().strip()
            expected =  main_test(X_train, X_test, Y_train, Y_test)
            self.assertEqual(output, expected)

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())
